/* lo22_projet1.c                                                    *
 *                                                                      *
 * Ce programme simule une partie de Black Jack entre 2 joueurs.        *
 * L'ordinateur ne joue pas, mais fais la donne.                        *
 * Looking for english comments ? If necessary, ask the author for it :	*
 * laurent.couvidou@utbm.fr                                             */

#include <stdio.h>
#include <stdlib.h>

#define LNOM 20 // Longueur des noms des joueurs

/* Fonction BlackJack : Droulement du jeu */

void BlackJack ( char * joueur0, char * joueur1, unsigned int parties0, unsigned int parties1 ) {

	unsigned int points[2] ={0,0} , as[2] = {0,0} , abandons = 0, joueur = 0, i=0 ;
	unsigned int cartes_tirees[52] ;	
	char rep ;
	
	for ( i=0 ; i<52 ; i++ ) {
	    cartes_tirees [i] = 0; // "Vidange" du tableau cartes_tirees
    }
	
	// 1) Donne de dpart
	
	for ( i=1 ; i<=2 ; i++) {
	
		printf("  %s tire : ",joueur0);
		points[0] = points[0] + TirerCarte ( &as[0] , cartes_tirees );
		printf("  %s tire : ",joueur1);
		points[1] = points[1] + TirerCarte ( &as[1] , cartes_tirees );
	}

	printf("\n"); // Saut de ligne

	// Affichage des points
		
	printf ("Points de %s : ",joueur0);
	printf("%d\n",points[0]);
	printf ("Points de %s : ",joueur1);
	printf("%d\n",points[1]);
		
	printf("\n"); // Saut de ligne

	while ( (points[0]<21) && (points[1]<21) && (abandons!=2) ) {
		
		// 2) Changement de valeur de l'as si victoire possible
		
		if ( (as[joueur] != 0)  && (points[joueur] == 11) ) {
		    
   			if (joueur==0) printf("%s : Passer la valeur de votre as a 11 (o/n) ? ", joueur0);
			if (joueur==1) printf("%s : Passer la valeur de votre as a 11 (o/n) ? ", joueur1);
			rep=getchar();
			getchar();
			while ( (rep!='o') && (rep!='n') ) {
				printf ("Rpondre par (o/n) : ");
				rep=getchar();
				getchar();
			}

			if (rep == 'o') {
				points[joueur] = points[joueur]+10;
				as[joueur] = 0;
			}

			printf("\n"); // Saut de ligne
			
			// Affichage des points
		
		    printf ("Points de %s : ",joueur0);
		    printf("%d\n",points[0]);
		    printf ("Points de %s : ",joueur1);
		    printf("%d\n",points[1]);
		
		    printf("\n"); // Saut de ligne
			
		}
		
		// 3) Tirage ventuel d'une nouvelle carte
		
		if (joueur==0) printf("%s : tirer une carte (o/n) ? ", joueur0);
		if (joueur==1) printf("%s : tirer une carte (o/n) ? ", joueur1);
		rep=getchar();
		getchar();

		while ( (rep!='o') && (rep!='n') ) {
			printf ("Rpondre par (o/n) : ");
			rep=getchar();
			getchar();
		}

		if (rep == 'o') {
			if (joueur==0) printf("  %s tire : ", joueur0);
			if (joueur==1) printf("  %s tire : ", joueur1);
			points[joueur] = points[joueur] + TirerCarte ( &as[joueur] , cartes_tirees );
			abandons = 0;
		}
		else {
			abandons++ ;
		}

		printf("\n"); // Saut de ligne
		
		// Affichage des points
		
		printf ("Points de %s : ",joueur0);
		printf("%d\n",points[0]);
		printf ("Points de %s : ",joueur1);
		printf("%d\n",points[1]);
		
		printf("\n"); // Saut de ligne
		
		joueur = (joueur+1)%2 ; // Passe de joueur 2  joueur 1 et rciproquement

	}
	
	// 4) Affichage du vainqueur
	
	// Conditions pour gagner :
	//   - faire 21 ou moins
	//   ET
	//   - faire plus que l'autre OU l'autre dpasse 21
	
	if ( (points[0]<=21) && ((points[0] > points[1]) || (points[1] > 21)) ) {
	
		printf ("Felicitations, %s, vous avez gagne !\n\n",joueur0);
		parties0 = parties0 + 1;
	}
	
	if ( (points[1]<=21) && ((points[1] > points[0]) || (points[0] > 21)) ) {
	
		printf ("Felicitations, %s, vous avez gagne !\n\n",joueur1);
		parties1 = parties1 + 1;
	}
	
	if ( points[1] == points[2] ) {
	
	    printf ("Egalite : personne n'a gagn...\n\n");
 	}
	
	// 5) Affichage des parties gagnes
	
	printf ( "%s", joueur0 );
	printf ( " a gagne %d partie(s)\n", parties0 );
	printf ( "%s", joueur1 );
	printf ( " a gagne %d partie(s)\n", parties1 );
	
	printf("\n"); // Saut de ligne
		
	// 6) Menu
	
	printf ("Et maintenant ?\n");
	printf ("  (a) Rejouer\n");
	printf ("  (b) Quitter et Sauver\n");
	printf ("  (c) Quitter sans Sauver \n");
	printf ("Choisir (a/b/c) : ");
	rep=getchar();
	getchar();

	while ( (rep!='a') && (rep!='b') && (rep!='c') ) {
		printf ("Rpondre par (a/b/c) : ");
		rep=getchar();
		getchar();
	}

	switch (rep) {
		
		case 'a' : printf("\n");
			   BlackJack ( joueur0, joueur1, parties0, parties1 );
			   break;

		case 'b' : Sauver ( joueur0, joueur1, parties0, parties1 );
			   break;

		case 'c' : printf("\n");
			   break;

		default : ;

	}
}

/* Fonction Sauver : Sauvegarde les noms des joueurs et les parties     *
 * gagnes dans score.txt                                               */

int Sauver ( char *joueur0, char *joueur1, unsigned int parties0, unsigned int parties1 ) {

	FILE * fichier;
	fichier = fopen ("score.txt","w");

	if (fichier != NULL ) {
		fprintf ( fichier, "%s", joueur0 );
		fprintf ( fichier, " a gagne %d partie(s)\n", parties0 );
		fprintf ( fichier, "%s", joueur1 );
		fprintf ( fichier, " a gagne %d partie(s)\n", parties1 );
		printf ("Fichier score.txt sauve !\n\n");
	}

	return 0;
	
}

/* Fontion TirerCarte : Tire une carte alatoire parmi 52, gre la      *
 * "disparition" des carrtes.                                           */

int TirerCarte (unsigned int *as, unsigned int cartes_tirees[]){

	int carte=0;
	int i=0;
        int test=0;
        int couleur=0;
        int hauteur=0;
        char * nom_couleur;
        char * nom_hauteur;

	while(test==0){ // Tant que la carte est dj tire, on ressaye
	
		carte=1+(int) (52.0*rand()/(RAND_MAX+1.0));
        // Donne un entier pseudo-alatoire entre 1 et 52
		
        test=1;
		i=0;
		for ( i=0 ; i<52 ; i++ ) {
			if (carte==cartes_tirees[i]) test=0; // Carte dj tire ?
		}
		
	}

        couleur = (int)((carte-1)/13); // Dtermine la couleur de la carte
        hauteur = carte-couleur*13; // Dtermine la hauteur de la carte
	
        switch (couleur) {
		
		case 0 : nom_couleur="coeur";
			 break;
		case 1 : nom_couleur="carreau";
			 break;
		case 2 : nom_couleur="pique";
			 break;
		case 3 : nom_couleur="trefle";
			 break;
		default : ;
	}
	
        switch (hauteur) {

		case 1 : nom_hauteur="as";
			 (*as)++;
			 break;
		case 2 : nom_hauteur="deux";
			 break;
		case 3 : nom_hauteur="trois";
			 break;
		case 4 : nom_hauteur="quatre";
			 break;
		case 5 : nom_hauteur="cinq";
			 break;
		case 6 : nom_hauteur="six";
			 break;
		case 7 : nom_hauteur="sept";
			 break;
		case 8 : nom_hauteur="huit";
			 break;
		case 9 : nom_hauteur="neuf";
			 break;
		case 10 : nom_hauteur="dix";
			 break;
		case 11 : nom_hauteur="valet";
			  break;
		case 12 : nom_hauteur="dame";
			  break;
		case 13 : nom_hauteur="roi";
			  break;
		default : ;
	}
	
    printf("%s de %s\n",nom_hauteur,nom_couleur);

	if(hauteur<=10){
		return hauteur;
	}
	else{
		return 10; // Toutes les ttes valent 10
	}
	
}

/* Fonction main : Enregistrement des noms et lancement du Black Jack	  */

int main(){

	char joueur0[LNOM];
	char joueur1[LNOM];

	srand((unsigned int) time(NULL) + getpid());
	// Initialise le gnrateur d'entiers pseudo-alatoires
	
	printf ("\n** Jeu de Black Jack pour deux **\n\n");
	printf ("Nom du premier joueur ? ");
	scanf ("%s", joueur0);
	getchar();
	printf ("Nom du second joueur ? ");
	scanf ("%s", joueur1);
	getchar();

	printf("\n"); // Saut de ligne

	BlackJack (joueur0, joueur1, 0, 0);

	getchar(); // Pause avant de quitter

	return 0;
	
}
